module ShapePicture_Editor exposing (main)
--Browser
import Browser
import Browser.Navigation as Nav
-- Url
import Url
-- Own
import TypeHolder exposing (Model, Msg(..))
import Manager.UpdateManager exposing (update)
import Manager.ViewManager   exposing (view)
import Manager.StateManager  as StM

main = Browser.application
        { init = init
        , subscriptions = subscriptions
        , update = update
        , view = documentView
        , onUrlChange = UrlChanged
        , onUrlRequest = LinkClicked
        }

-- INIT
init : () -> Url.Url -> Nav.Key-> (Model, Cmd Msg)
init _ url key =
    ( Model
        StM.Standby
        []
        0
        (Ok " Init")
        url
        key
    , Cmd.none
    )
-- SUBSCRIPTIONS
subscriptions : Model -> Sub Msg
subscriptions model = Sub.none
-- VIEW
documentView : Model -> Browser.Document Msg
documentView model = { title = "ShapePicture_Editor"
                     , body = [view model]
                     }